package com.surekam.crawler;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.LinkedBlockingQueue;

import org.htmlparser.NodeFilter;
import org.htmlparser.Parser;
import org.htmlparser.filters.TagNameFilter;
import org.htmlparser.tags.LinkTag;
import org.htmlparser.util.NodeList;
import org.htmlparser.util.ParserException;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;

import com.surekam.crawler.util.ContainChar;

/**
 * Classѡõһhtmlclass
 * 
 * @author wu
 * 
 */
public class ChoeseClass {

	
	public static String url = "http://www.stats.gov.cn/tjbz/cxfldm/2012/43.html";// վַ

	public static String chose = ".citytable";// Ĺʵһҳһclass =
												// '.tt1'ҳ

	static BlockingQueue<String> queue = new LinkedBlockingQueue<String>(10);

	public static void main(String[] args) throws IOException {
		ExecutorService service = Executors.newCachedThreadPool();
		Thread t1 = new CatchURL(queue);
		service.execute(t1);//ץȡӵַǵ̵߳
		Thread t2 = new DownLoadHtml(queue);
		for (int i = 0; i < 10; i++) {//ҳö߳
			service.execute(t2);
		}

	}

}

class DownLoadHtml extends Thread {

	
	private BlockingQueue<String> queue;
	
	public DownLoadHtml(BlockingQueue<String> queue){
		this.queue = queue;
	}

	@Override
	public void run() {
		try {
			while (true) {
				System.out.println(Thread.currentThread().getName());
				//System.out.println(this.queue.take().toString());
				new MirroCraw(this.queue.take().toString(), "G://test//local");
				// Thread.sleep(10000);// õȴʱΪ10ӣһҳʱΪ10
				if (this.queue.size() == -1)// һֱжǷûд
					break;
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}

class CatchURL extends Thread {
	
	private BlockingQueue<String> queue;
	
	public CatchURL(BlockingQueue<String> queue){
		this.queue = queue;
	}

	@Override
	public void run() {
		try {
			choClass(ChoeseClass.url, ChoeseClass.chose);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void  choClass(String url, String chose) throws IOException {
		Document doc = null;
		doc = Jsoup.connect(url).timeout(30000).get();
		String classes = chose;
		Elements el = doc.select(classes);
		List<String> links = getPageLinks(el.toString());
		List<String> tempLinks = new ArrayList<>();
		for (String string : links) {
			if(!tempLinks.contains(string)) {
				tempLinks.add(string);
			}
		}
		// urlһЩװ
		for (String string : tempLinks) {
			if (!(string.equals("#"))) {
				if (!string.startsWith("http://")) {
					if (string.startsWith("/")) {
						string = assemblyUrl(url) + string;
					} else {
						if (string.startsWith("../")) {// ֿͷӦϼĿ¼../Ŀ¼
							string = string.replace("../", "");
							string = url.substring(0,
									url.substring(0, url.lastIndexOf("/"))
											.lastIndexOf("/") + 1)
									+ string;
						} else {
							string = url.substring(0, url.lastIndexOf("/") + 1)
									+ string;

						}
					}

				}
				if (!string.contains(url)) {
					this.queue.add(string);
					System.out.println("ӣ"+Thread.currentThread().getName() + "  " + string);
					int i = ContainChar.ContainCharByStr(string);
					if (i == 7) {
						choClass(string, ".countytable");
					}
					if (i == 8) {
						choClass(string, ".towntable");
					}
					if (i == 9) {
						choClass(string, ".towntable");
					}
				}
			}
		}
	}

	protected static List<String> getPageLinks(String html) {
		Parser parser = null;
		NodeList nodeList = null;
		NodeFilter filter = null;
		List<String> urlList = new ArrayList<String>();
		try {
			// ָParser
			parser = Parser.createParser(html, "GB18030");
			// һܱǩAĹ
			filter = new TagNameFilter("A");
			// ˽ڵ
			nodeList = parser.extractAllNodesThatMatch(filter);
			int size = nodeList.size();
			for (int i = 0; i < size; i++) {
				LinkTag tag = (LinkTag) nodeList.elementAt(i);
				// System.out.println(tag.getLink());
				urlList.add(tag.getLink());
			}
		} catch (ParserException e) {
			e.printStackTrace();
		}
		return urlList;
	}

	/**
	 * װurl
	 * 
	 * @param url
	 */
	public static String assemblyUrl(String url) {
		if (url.startsWith("http://")) {
			String newUrl = url.substring(0, url.indexOf("/", 8));
			return newUrl;
		}
		return url;

	}
}
