package com.surekam.crawler;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.ProtocolException;
import java.net.URL;
import java.util.logging.Logger;

/**
 * ļ
 * @author wu
 *
 */
public class MirroCraw {

	private static final Logger logger = Logger.getLogger(MirroCraw.class
			.getName());
	String urlString;
	String localPath;

	public static void main(String[] args) throws Exception {
		new MirroCraw("http://www.stats.gov.cn/tjbz/cxfldm/2012/43.html",
				"G://test//local");
	}

	public MirroCraw(String urlString, String localPath) throws Exception {
		if (urlString == "shut-down") {
			return;
		}
		this.urlString = urlString;
		this.localPath = localPath;
		/*
		 * String tempPath = urlString.substring(0, urlString.indexOf("/", 8));
		 * String fileName = urlString.substring(urlString.lastIndexOf("/")+1,
		 * urlString.length());
		 */
		// System.out.println(tempPath);
		// System.out.println(fileName);
		run();
	}

	public void run() throws Exception {
		int cc = urlString.indexOf("/", 8);
		String tempPath = urlString.substring(7, urlString.indexOf("/", 8));
		String fileName = urlString.substring(urlString.lastIndexOf("/") + 1,
				urlString.length());
		if (fileName.contains("?")) {
			fileName = fileName.replace('?', '_');//aa.jsp?id=123ָʽдļʱheritrixķǸĳaaid=123.jsp,ҵдaa.jsp_id=123ֱ
		}
		if (fileName.equals("")) {
			return;
		}
		String charset = "GBK";
		//String charset = getEncoding(urlString);//õĵıʽΪֱӽĵõĸʽ̫ã֪ʲô취õĵʽ
		URL url = new URL(urlString);
		if (charset == null) {//ΪգĬΪGBKǲ˼վĽĬϵGBKûо
			charset = "GBK";
		}
		HttpURLConnection urlConnection = (HttpURLConnection) url
				.openConnection();

		String newline;
		BufferedReader readers = new BufferedReader(new InputStreamReader(
				urlConnection.getInputStream(), charset));
		// System.out.println(localPath+"//"+tempPath);
		File f = new File(localPath + "//" + tempPath);
		f.mkdirs();
		String local = f + "\\" + fileName;

		FileWriter fw = new FileWriter(local);
		while ((newline = readers.readLine()) != null) {
			// System.out.println(newline);
			fw.write(newline);
			fw.write("\n");
		}
		readers.close();
		fw.close();
		logger.info(urlString + " -> " + local);
	}

	/**
	 * õҳıʽ
	 * 
	 * @param Url
	 * @return
	 * @throws Exception
	 */
	public String getEncoding(String Url) throws Exception {
		// һURL
		URL url = new URL(Url);

		// ҳıʽ
		String charset = null;
		// URL
		HttpURLConnection urlConnection = null;
		try {
			urlConnection = (HttpURLConnection) url.openConnection();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		// System.out.println(urlConnection.getResponseCode());
		try {
			urlConnection.setRequestMethod("GET");
		} catch (ProtocolException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		// õҳ
		BufferedReader reader = null;
		try {
			reader = new BufferedReader(new InputStreamReader(urlConnection
					.getInputStream()));
		} catch (IOException e) {
			logger.info(Url + " :ַҲ");
		}
		String line;
		// ȡݣʾ
		while ((line = reader.readLine()) != null) {
			// õҳıʽ
			if (line.contains("charset")) {
				int location = line.indexOf("charset");
				String encoding = line.substring(location + 8);
				String charsets[] = encoding.split("\"");
				charset = charsets[0];
				break;
			}
		}
		reader.close();
		return charset;
	}
}
